"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const fs_1 = __importDefault(require("fs"));
function fileExists(filePath) {
    try {
        return fs_1.default.statSync(filePath).isFile();
    }
    catch (err) {
        return false;
    }
}
function search_for_file_upwards(start, filename) {
    let current_dir = start;
    let file_path = path_1.default.resolve(current_dir, filename);
    while (!fileExists(file_path)) {
        if (current_dir == "/") {
            throw new Error("Could not find '" +
                filename +
                "' in any of the parent directories.");
        }
        current_dir = path_1.default.resolve(current_dir, "../");
        file_path = path_1.default.resolve(current_dir, filename);
    }
    return file_path;
}
function locreq_resolve(caller_path, module_path) {
    const package_path = search_for_file_upwards(caller_path, "package.json");
    return path_1.default.resolve(package_path, "../", module_path);
}
function locreq(caller_path, module_path) {
    return require(locreq_resolve(caller_path, module_path));
}
function curry_locreq(caller_path) {
    let curried = (() => {
        const f = function (module_path) {
            return locreq(caller_path, module_path);
        };
        f.resolve = function (module_path) {
            return locreq_resolve(caller_path, module_path);
        };
        return f;
    })();
    return curried;
}
exports.default = curry_locreq;
//# sourceMappingURL=index.js.map